'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dummy = exports.flush = exports.instance = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _lruCache = require('lru-cache');

var _lruCache2 = _interopRequireDefault(_lruCache);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var caches = void 0;

var init = function init() {
  if (!caches) {
    caches = new Map();
  }
};

/**
 * @param {String} ns
 * @return {LRU}
 */
var instance = exports.instance = function instance() {
  var ns = arguments.length <= 0 || arguments[0] === undefined ? 'default' : arguments[0];

  init();

  if (!caches.has(ns)) {
    caches.set(ns, new _lruCache2.default({
      max: 256,
      maxAge: 15 * 60 * 1000 }));
  }

  return caches.get(ns);
};

/**
 * @param void
 * @return void
 */
var flush = exports.flush = function flush() {
  init();

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = caches.entries()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var _step$value = _slicedToArray(_step.value, 2);

      var ns = _step$value[0];
      var cache = _step$value[1];

      cache.reset();
      caches.delete(ns);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
};

/**
 * @param void
 * @return {Object}
 */
var dummy = exports.dummy = function dummy() {
  var noop = function noop() {};

  return {
    length: 0,
    itemCount: 0,
    get: noop,
    set: noop,
    reset: noop,
    peek: noop,
    del: noop,
    has: function has() {
      return false;
    },
    forEach: noop,
    rforEach: noop,
    keys: function keys() {
      return [];
    },
    values: function values() {
      return [];
    },
    dump: function dump() {
      return [];
    }
  };
};

exports.default = { instance: instance, flush: flush, dummy: dummy };