'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ProductOptionValue = exports.Manufacturer = exports.StockAvailable = exports.Combination = exports.Image = exports.Product = exports.Language = exports.Model = undefined;

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _lang = require('./lang');

var _lang2 = _interopRequireDefault(_lang);

var _querystring = require('./querystring');

var _querystring2 = _interopRequireDefault(_querystring);

var _rest = require('./rest');

var _lodash = require('lodash');

var _exceptions = require('./exceptions');

var _sort = require('./sort');

var _sort2 = _interopRequireDefault(_sort);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var P = Promise;
var _lang$coerce = _lang2.default.coerce;
var bool = _lang$coerce.bool;
var integer = _lang$coerce.integer;
var number = _lang$coerce.number;
var string = _lang$coerce.string;

////////////////////////////////////////////////////////////////////////////////

var models = {};

exports.default = models;
var Model = exports.Model = models.Model = function () {
  _createClass(_class, [{
    key: 'defaults',


    /**
     * Return default model attributes
     * @param void
     * @return {Object}
     */
    value: function defaults() {
      return {
        // the resource that created the model
        resource: null,

        // rest.Client instance
        client: null,

        // model properties
        props: {}
      };
    }

    /**
     * Define property mutators
     * @param void
     * @return {Object}
     */

  }, {
    key: 'mutators',
    value: function mutators() {
      return {
        // property: [set-mutator, get-mutator],
        id: [integer],
        quantity: [integer],
        position: [integer]
      };
    }

    /**
     * @param {Object} attrs - initial model attributes
     */

  }]);

  function _class() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, _class);

    this.options = _extends({}, this.defaults(), options);

    var props = options.props || {};
    this.set(_extends({}, this.options.props, props));
  }

  /**
   * Assign a single property or mass-assign multiple properties. Map
   * property values through the dictionary returned by mutators().
   * @param ...mixed args
   * @return void
   */


  _createClass(_class, [{
    key: 'set',
    value: function set() {
      var _this = this;

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var arity = args.length;
      var mutators = this.mutators();
      var defaults = [function (v) {
        return v;
      }];

      var assign = function assign(value, prop) {
        var _ref = mutators[prop] || defaults;

        var _ref2 = _slicedToArray(_ref, 1);

        var set = _ref2[0];

        _this[prop] = set(value);
      };

      if (arity < 1) {
        throw new Error('expected at least one argument');
      }
      if (arity > 2) {
        throw new Error('expected no more than two arguments');
      }

      if (arity === 1) {
        (0, _lodash.each)(args[0], assign);
        return;
      }

      var prop = args[0];
      var value = args[1];

      assign(value, prop);
    }
  }]);

  return _class;
}();

var Language = exports.Language = models.Language = function (_Model) {
  _inherits(_class2, _Model);

  function _class2() {
    _classCallCheck(this, _class2);

    return _possibleConstructorReturn(this, (_class2.__proto__ || Object.getPrototypeOf(_class2)).apply(this, arguments));
  }

  return _class2;
}(Model);

var Product = exports.Product = models.Product = function (_Model2) {
  _inherits(_class3, _Model2);

  function _class3() {
    _classCallCheck(this, _class3);

    return _possibleConstructorReturn(this, (_class3.__proto__ || Object.getPrototypeOf(_class3)).apply(this, arguments));
  }

  _createClass(_class3, [{
    key: 'mutators',


    /**
     * @inheritdoc
     */
    value: function mutators() {
      return _extends({}, _get(_class3.prototype.__proto__ || Object.getPrototypeOf(_class3.prototype), 'mutators', this).call(this), {
        price: [number],
        available_for_order: [integer, bool]
      });
    }

    /**
     * Return a rest.Resource that provides access to the related Manufacturer
     * @param void
     * @return {rest.resources.Combinations}
     */

  }, {
    key: 'manufacturer',
    value: function manufacturer() {
      var _this4 = this;

      return new _rest.resources.Manufacturers({
        client: this.options.client,
        filter: function filter(manufacturer) {
          return _this4.related.manufacturer == manufacturer.id;
        }
      });
    }

    /**
     * Return a rest.Resource that provides access to related Images
     * @param void
     * @return {rest.resources.Images}
     */

  }, {
    key: 'images',
    value: function images() {
      return new _rest.resources.Images({
        client: this.options.client,
        root: '/images/products/' + this.id
      });
    }

    /**
     * Return a rest.Resource that provides access to related Combinations
     * @param void
     * @return {rest.resources.Combinations}
     */

  }, {
    key: 'combinations',
    value: function combinations() {
      var _this5 = this;

      return new _rest.resources.Combinations({
        client: this.options.client,
        filter: function filter(combo) {
          return _this5.related.combinations.indexOf(combo.id) > -1;
        }
      });
    }
  }]);

  return _class3;
}(Model);

var Image = exports.Image = models.Image = function (_Model3) {
  _inherits(_class4, _Model3);

  function _class4() {
    _classCallCheck(this, _class4);

    return _possibleConstructorReturn(this, (_class4.__proto__ || Object.getPrototypeOf(_class4)).apply(this, arguments));
  }

  return _class4;
}(Model);

var Combination = exports.Combination = models.Combination = function (_Model4) {
  _inherits(_class5, _Model4);

  function _class5() {
    _classCallCheck(this, _class5);

    return _possibleConstructorReturn(this, (_class5.__proto__ || Object.getPrototypeOf(_class5)).apply(this, arguments));
  }

  _createClass(_class5, [{
    key: 'mutators',


    /**
     * Define property mutators
     * @param void
     * @return {Object}
     */
    value: function mutators() {
      return _extends({}, _get(_class5.prototype.__proto__ || Object.getPrototypeOf(_class5.prototype), 'mutators', this).call(this), {
        id_product: [integer],
        quantity: [integer],
        price: [number],
        ecotax: [number],
        weight: [number],
        unit_price_impact: [number],
        minimal_quantity: [number]
      });
    }

    /**
     * Return a rest.Resource that provides access to the parent Product
     * @param void
     * @return {rest.resources.Products}
     */

  }, {
    key: 'product',
    value: function product() {
      var _this8 = this;

      return new _rest.resources.Product({
        client: this.options.client,
        filter: function filter(product) {
          return _this8.related.product == product.id;
        }
      });
    }

    /**
     * Return a rest.Resource that provides access to related ProductOptionValues
     * @param void
     * @return {rest.resources.ProductOptionvalues}
     */

  }, {
    key: 'product_option_values',
    value: function product_option_values() {
      var _this9 = this;

      return new _rest.resources.ProductOptionValues({
        client: this.options.client,
        filter: function filter(pov) {
          return _this9.related.product_option_values.indexOf(pov.id) > -1;
        }
      });
    }
  }, {
    key: 'stock_availables',
    value: function stock_availables() {
      var _this10 = this;

      return new _rest.resources.StockAvailables({
        client: this.options.client,
        filter: function filter(stock) {
          return stock.id_product_attribute == _this10.id;
        }
      });
    }
  }]);

  return _class5;
}(Model);

var StockAvailable = exports.StockAvailable = models.StockAvailable = function (_Model5) {
  _inherits(_class6, _Model5);

  function _class6() {
    _classCallCheck(this, _class6);

    return _possibleConstructorReturn(this, (_class6.__proto__ || Object.getPrototypeOf(_class6)).apply(this, arguments));
  }

  _createClass(_class6, [{
    key: 'mutators',


    /**
     * @inheritdoc
     */
    value: function mutators() {
      return _extends({}, _get(_class6.prototype.__proto__ || Object.getPrototypeOf(_class6.prototype), 'mutators', this).call(this), {
        id_product: [integer],
        id_product_attribute: [integer],
        id_shop: [integer],
        id_shop_group: [integer],
        quantity: [integer],
        depends_on_stock: [integer],
        out_of_stock: [integer]
      });
    }
  }]);

  return _class6;
}(Model);

var Manufacturer = exports.Manufacturer = models.Manufacturer = function (_Model6) {
  _inherits(_class7, _Model6);

  function _class7() {
    _classCallCheck(this, _class7);

    return _possibleConstructorReturn(this, (_class7.__proto__ || Object.getPrototypeOf(_class7)).apply(this, arguments));
  }

  return _class7;
}(Model);

var ProductOptionValue = exports.ProductOptionValue = models.ProductOptionValue = function (_Model7) {
  _inherits(_class8, _Model7);

  function _class8() {
    _classCallCheck(this, _class8);

    return _possibleConstructorReturn(this, (_class8.__proto__ || Object.getPrototypeOf(_class8)).apply(this, arguments));
  }

  return _class8;
}(Model);