'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.stringify = undefined;

var _lodash = require('lodash');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

////////////////////////////////////////////////////////////////////////////////
var querystring = {};

exports.default = querystring;

/**
 * Stringify a query per RFC 3986
 * @param {Object} query
 * @return {String}
 */

var stringify = exports.stringify = querystring.stringify = function (query) {
  var encode = encodeURIComponent;
  var serialize = function serialize(k, v) {
    return encode(k) + '=' + encode(v);
  };

  if (Array.isArray(query)) {
    return (0, _lodash.map)(query, function (tuple) {
      return serialize.apply(undefined, _toConsumableArray(tuple));
    }).join('&');
  }

  return (0, _lodash.map)(query, function (v, k) {
    return serialize(k, v);
  }).join('&');
};