"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var sort = {};

/**
 * Return a sort comparator given a function that returns a sortable value.
 * @param {Function} resolve
 * @return {Function}
 */
var ascending = exports.ascending = sort.ascending = function (resolve) {
  return function (a, b) {
    return resolve(a) - resolve(b);
  };
};

/**
 * Return a sort comparator given a function that returns a sortable value.
 * @param {Function} resolve
 * @return {Function}
 */
var descending = exports.descending = sort.descending = function (resolve) {
  return function (a, b) {
    return resolve(b) - resolve(a);
  };
};

exports.default = sort;